/*
 * Delivered to the U.S. Government in Accordance with Contract FA8650-10-C-7080.
 *
 * EXPORT CONTROLLED
 * ECCN#   EAR99
 * Warning: This document contains technical data which is controlled under the
 * Bureau of Industry & Security's Export Administration Regulations and may not be
 * exported or re-exported without authorization by the Bureau of Industry & Security.
 * Diversion contrary to US law is prohibited.
 *
 * (c) 2011 United Technologies Corp.
 * Developed with the sponsorship of the Defense Advanced Research Projects Agency (DARPA).
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this data,
 * including any software or models in source or binary form, as well as any drawings, 
 * specifications, and documentation (collectively "the Data"), to deal in the Data without 
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Data, and to permit persons to whom the Data
 * is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Data.
 *
 * THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE DATA OR THE
 * USE OR OTHER DEALINGS IN THE DATA.
*/

package aee.engine;

import org.jdom.Attribute;
import org.jdom.DataConversionException;
import org.jdom.Element;

import aee.exception.AeeException;

/**
 * A device object. These are defined in a device table
 */
public abstract class Device extends NamedObject {
	private Integer minOccurs;
	private Integer maxOccurs;
	private Integer maxBpr;	
	protected static String ElementName = "device";
	
	/**
	 * Constructor builds a device from XML 
	 * @param root The root "device" element
	 * @throws AeeException if any unexpected XML errors detected
	 */
	public Device(Element root) throws AeeException {
		super(root, ElementName);
		
		minOccurs = null;
		maxOccurs = null;
		maxBpr    = null;
		
		// All attributes are optional
		String attrName = "";
		try {
			attrName       = "min";
			Attribute attr = root.getAttribute(attrName);
			if (attr != null) {
				if (! "".equals(getAttrValue(attr)))
					minOccurs = attr.getIntValue();
			}
			
			attrName = "max";
			attr     = root.getAttribute(attrName);
			if (attr != null) {
				if (! "".equals(getAttrValue(attr)))
					maxOccurs = attr.getIntValue();
			}
			
			attrName = "maxbpr";
			attr     = root.getAttribute(attrName);
			if (attr != null) {
				if (! "".equals(getAttrValue(attr)))
					maxBpr = attr.getIntValue();
			}
			
		} catch (DataConversionException dcex) {
			throw new AeeException("Element %s Attribute %s: %s",
					                    ElementName, attrName, dcex.getMessage());
		}
	}
	
	/**
	 * Report all CSV fields
	 * @return An array of CSV fields
	 */
	public abstract String[] getCsvFields();
	
	/**
	 * Report header 1 fields
	 * @return Header 1
	 */
	public abstract String[] getHeader1();
	
	/**
	 * Report header 2 fields
	 * @return Header 2
	 */
	public abstract String[] getHeader2();

	/**
	 * Report the min value
	 * @return null if min is missing else the value
	 */
	protected Integer getMin() {
		return (minOccurs == null)? null : new Integer(minOccurs);
	}
	
	/**
	 * Report the min value as a string
	 * @return "" if min is missing else the value
	 */
	protected String getMinAsString() {
		return intToString(minOccurs);
	}
	
	/**
	 * Report the max value
	 * @return null if min is missing else the value
	 */
	protected Integer getMax() {
		return (maxOccurs == null)? null : new Integer(maxOccurs);
	}
	
	/**
	 * Report the max value as a string
	 * @return "" if max is missing else the value
	 */
	protected String getMaxAsString() {
		return intToString(maxOccurs);
	}

	/**
	 * Report the maxbpr value
	 * @return null if maxbpr is missing else the value
	 */
	protected Integer getMaxBpr() {
		return (maxBpr == null)? null : new Integer(maxBpr);
	}
	
	/**
	 * Report the maxbpr value as a string
	 * @return "" if maxbpr is missing else the value
	 */
	protected String getMaxBprAsString() {
		return intToString(maxBpr);
	}

}
